## xrt 202520.2.20.151

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2018-2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2022 Advanced Micro Devices, Inc. All rights reserved.
cmake_minimum_required(VERSION 3.5...4.0)
project(XRT)
set(PROJECT_DESCRIPTION "https://github.com/Xilinx/XRT")

# Include utility functions
include(CMake/utilities.cmake)

# Include supporting CMake functions
include(CMake/unitTestSupport.cmake)

# Exported interface into XRT for include from implemenation
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src/core/include
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src/core/common/gsl/include
  ${XRT_BINARY_DIR}/gen
  ${XRT_BINARY_DIR}
  )

include(CMake/settings.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${XRT_SOURCE_DIR}/CMake/")

# This makes aiebu submodule use ELFIO from XRT
set(AIEBU_ELFIO_SRC_DIR "${XRT_SOURCE_DIR}/runtime_src/core/common/elf")

if (NOT XRT_EDGE)
  # Enable testing for this directory and below.  This command should be
  # in the source directory root because ctest expects to find a test
  # file in the build directory root.
  enable_testing()

  # Temporary native wrapper while Linux code is being ported to windows.
  # When completed the two build flows will once again be merged into one
  # common file
  if (WIN32)
    include(CMake/nativeWin.cmake)
  else()
    include(CMake/nativeLnx.cmake)
  endif()
  xrt_include(CMake/nativeTests.cmake)
else()
  include(CMake/embedded_system.cmake)
endif()

=== src/runtime_src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#

# Note: Add Windows compilation directives at the END of this file

if( NOT WIN32)

if(${CMAKE_BUILD_TYPE} STREQUAL "Release" AND (NOT XRT_EDGE))
  xrt_add_subdirectory(doc)
endif()

option(XOCL_VERBOSE "Enable xocl verbosity" OFF)
option(XRT_VERBOSE "Enable xrt verbosity" OFF)

if (XOCL_VERBOSE)
  add_compile_options("-DXOCL_VERBOSE")
endif()

if(XRT_VERBOSE)
  add_compile_options("-DXRT_VERBOSE")
endif()

add_compile_options("-fPIC")

if (XRT_ENABLE_WERROR)
  list(APPEND XRT_WARN_OPTS "-Werror")
endif(XRT_ENABLE_WERROR)

if (NOT XRT_EDGE)
  add_compile_options( ${XRT_WARN_OPTS} )
endif()
xrt_add_subdirectory(xdp)

xrt_add_subdirectory(tools/xclbinutil)
xrt_add_subdirectory(xocl)
xrt_add_subdirectory(xrt)

if (XRT_ALVEO)
  # Enable building of ERT firmware for Alveo
  xrt_add_subdirectory(ert)
endif()

# --- Optional HIP bindings ---
if (XRT_ENABLE_HIP)
  xrt_add_subdirectory(hip)
endif(XRT_ENABLE_HIP)

if (NOT XRT_EDGE)
  # Only for host native build.
  # For embedded, headers and libraries are installed in /usr
  # Not requeired setup.sh/.csh
  xrt_add_subdirectory(tools/scripts)
endif()

# Attach to the user's linker flags
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")

xrt_add_subdirectory(core)

else()
# = WINDOWS ===================================================================

  # Enable ALL warnings and make them errors if they occur
  if (MSVC)
    # warning level 4 and all warnings are errors
    add_compile_options(/WX /W4)
    if (DEFINED MSVC_PARALLEL_JOBS)
      string(CONCAT MP_OPTION "/MP" ${MSVC_PARALLEL_JOBS})
      add_compile_options(${MP_OPTION})
    endif()
  else()
    # lots of warnings and all warnings as errors
    # add_compile_options(-Wall -Wextra -pedantic -Werror)
    add_compile_options( ${XRT_WARN_OPTS} )
  endif()

  if (XRT_NPU)
    set(AIERT_DIR ${CMAKE_CURRENT_BINARY_DIR}/aie-rt/driver/src)
    set(XAIENGINE_BUILD_SHARED OFF)
    xrt_add_subdirectory_disable_install_target(aie-rt/driver/src)
    # This enables aiebu submodule use aie-rt from higher level
    set(AIEBU_AIE_RT_BIN_DIR ${AIERT_DIR})
    set(AIEBU_AIE_RT_HEADER_DIR ${AIERT_DIR}/include)
    message("-- Exporting AIEBU_AIE_RT_BIN_DIR=${AIEBU_AIE_RT_BIN_DIR}")
    message("-- Exporting AIEBU_AIE_RT_HEADER_DIR=${AIEBU_AIE_RT_HEADER_DIR}")
  endif()

  # Build Subdirectories
  xrt_add_subdirectory(xocl)
  xrt_add_subdirectory(xrt)
  xrt_add_subdirectory(tools/xclbinutil)
  xrt_add_subdirectory(xdp)
  xrt_add_subdirectory(tools/scripts)
  xrt_add_subdirectory(core)

  # --- Optional HIP bindings ---
  if (XRT_ENABLE_HIP)
    xrt_add_subdirectory(hip)
  endif(XRT_ENABLE_HIP)
endif()

=== tests/xrt/Makefile ===
#####################################################################################################################
# This makefile can be used to generate output files for all XRT example test
# To generate executable file run: make exe
# To generate xclbin file run: make xclbin
# To remove all the tests run: make clean
# To generate xclbin and exe files run: make all
# All generated output files locate in build/opt/$testcase where $testcase is testcase name
#####################################################################################################################
TARGETS := \
 00_hello \
 02_simple \
 03_loopback \
 04_swizzle \
 07_sequence \
 11_fp_mmult256 \
 13_add_one \
 15_buffer_size \
 22_verify \
 100_ert_ncu \
 102_multiproc_verify \
 103_multiproc

all:
	for t in $(TARGETS) ; do echo "Generating exe and xclbin files  .." ; cd  $$PWD/$$t ; make all  ;  cd .. ; done

clean:
	for t in $(TARGETS) ; do echo "Cleaning testcase .." ; cd  $$PWD/$$t ; make clean  ;  cd .. ; done

exe:
	for t in $(TARGETS) ; do echo "Compiling the host for test $$PWD/$$t .." ; cd  $$PWD/$$t ; make exe  ;  cd .. ;done

xclbin:
	for t in $(TARGETS) ; do echo "Creating xclbin for test  $$PWD/$$t .." ; cd  $$PWD/$$t ; make xclbin  ;  cd .. ; done

=== src/runtime_src/hip/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2023 Advanced Micro Devices, Inc. All rights reserved.

# config file for getting hip headers
include(hip_config.cmake)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  find_program(CLANG_TIDY "clang-tidy")
  if(NOT CLANG_TIDY)
    message(WARNING "-- clang-tidy not found, cannot enable static analysis")
  else()
    message("-- Enabling clang-tidy")
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy")
  endif()
endif()

add_subdirectory(core)
add_subdirectory(api)

if (WIN32)
  add_library(xrt_hip SHARED
    $<TARGET_OBJECTS:hip_core_library_objects>
    $<TARGET_OBJECTS:hip_api_library_objects>
    xrt_hip.def
  )
else()
  add_library(xrt_hip SHARED
    $<TARGET_OBJECTS:hip_core_library_objects>
    $<TARGET_OBJECTS:hip_api_library_objects>
  )
endif()

target_include_directories(xrt_hip
  PRIVATE
  ${XRT_SOURCE_DIR}/runtime_src
)

target_link_libraries(xrt_hip
  PRIVATE
  xrt_coreutil
)

set_target_properties(xrt_hip PROPERTIES
  VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
)

install(TARGETS xrt_hip
  EXPORT xrt-targets
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_COMPONENT} NAMELINK_COMPONENT ${XRT_BASE_DEV_COMPONENT}
  ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

# Release headers
install (FILES xrt_hip.h
  DESTINATION ${XRT_INSTALL_INCLUDE_DIR}/xrt
  COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

=== src/runtime_src/xocl/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${XRT_SOURCE_DIR}/include/1_2
)

set(XRT_XOCL_API_DIR       "${CMAKE_CURRENT_SOURCE_DIR}/api")
set(XRT_XOCL_CORE_DIR      "${CMAKE_CURRENT_SOURCE_DIR}/core")
set(XRT_XOCL_XCLBIN_DIR    "${CMAKE_CURRENT_SOURCE_DIR}/xclbin")

include_directories(
  ${XRT_XOCL_API_DIR}
)

file(GLOB XRT_XOCL_API_FILES
  "${XRT_XOCL_API_DIR}/*.cpp"
  "${XRT_XOCL_API_DIR}/detail/*.cpp"
  "${XRT_XOCL_API_DIR}/icd/*.cpp"
  "${XRT_XOCL_API_DIR}/khronos/*.cpp"
  "${XRT_XOCL_API_DIR}/xlnx/*.cpp"
  "${XRT_XOCL_API_DIR}/printf/*.cpp"
  "${XRT_XOCL_API_DIR}/plugin/xdp/*.cpp"
  )

file(GLOB XRT_XOCL_CORE_FILES
  "${XRT_XOCL_CORE_DIR}/*.cpp"
  )

file(GLOB XRT_XOCL_XCLBIN_FILES
  "${XRT_XOCL_XCLBIN_DIR}/*.cpp"
  )

set(XRT_XOCL_ALL_SRC
  ${XRT_XOCL_API_FILES}
  ${XRT_XOCL_CORE_FILES}
  ${XRT_XOCL_XCLBIN_FILES}
  )

add_compile_options("-DXRT_XOCL_SOURCE")

add_library(xocl OBJECT ${XRT_XOCL_ALL_SRC})

if (WIN32)
include_directories(
  ${KHRONOS}/include
  )

add_library(xilinxopencl SHARED
  $<TARGET_OBJECTS:xocl>
  ${XRT_XOCL_API_DIR}/icd/windows/xilinxopencl.def
  )

add_library(xilinxopencl_static STATIC
  $<TARGET_OBJECTS:xocl>
  )

target_link_libraries(xilinxopencl
  PRIVATE
  xrt++
  xrt_coreutil
  )

else ()

add_library(xilinxopencl SHARED $<TARGET_OBJECTS:xocl>)
add_library(xilinxopencl_static STATIC $<TARGET_OBJECTS:xocl>)

# Attach to the user's linker flags
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")

set_target_properties(xilinxopencl PROPERTIES
  LINKER_LANGUAGE CXX
  VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
  )

target_link_libraries(xilinxopencl
  PRIVATE
  xrt++
  xrt_coreutil
  dl
  pthread
  crypt
  uuid
  rt
  )

  # On linux use xrt_coreutil.a
  set_target_properties(xilinxopencl_static PROPERTIES OUTPUT_NAME "xilinxopencl")

endif ()

install(TARGETS xilinxopencl xilinxopencl_static
  EXPORT xrt-targets
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_COMPONENT} NAMELINK_COMPONENT ${XRT_BASE_DEV_COMPONENT}
  ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

set(CL_DEST_DIR ${XRT_INSTALL_INCLUDE_DIR}/)
if(XRT_EDGE)
  set(CL_DEST_DIR ${XRT_INSTALL_INCLUDE_DIR}/xrt/)
endif()

# Release OpenCL extension headers
install (FILES
  ${XRT_SOURCE_DIR}/include/1_2/CL/cl_ext_xilinx.h
  DESTINATION ${CL_DEST_DIR}/CL
  COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

# Preserve legacy behavior in legacy XRT package. The component
# setup will have defined XRT_BASE_DEV_COMPONENT to XRT
if (XRT_XRT OR XRT_EDGE)
  install (FILES
    ${XRT_SOURCE_DIR}/include/1_2/CL/cl_ext.h
    ${XRT_SOURCE_DIR}/include/1_2/CL/cl2xrt.hpp
    DESTINATION ${CL_DEST_DIR}/CL
    COMPONENT ${XRT_BASE_DEV_COMPONENT}
    )
endif ()

=== tests/unit_test/2kernelglobal_002_rw_4ddr_512/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
set(TESTNAME "2kernelglobal_002_rw_4ddr_512")
PROJECT(${TESTNAME})

include(../../CMake/utils.cmake)

add_executable(${TESTNAME} main.cpp)
target_link_libraries(${TESTNAME} PRIVATE ${xrt_xilinxopencl_LIBRARY})

if (NOT WIN32)
  target_link_libraries(${TESTNAME} PRIVATE ${uuid_LIBRARY} pthread)
endif(NOT WIN32)

if (DEFINED ENV{XCLBIN_CREATION})
  if (DEFINED ENV{XCL_EMULATION_MODE})
    xrt_create_emconfig(${PLATFORM})
  endif()

  set(XOS "")
  set(XO_TARGETS "")

  # xrt_create_xo is a macro defined in utils.cmake for generating xo file
  xrt_create_xo(
    "${CMAKE_CURRENT_SOURCE_DIR}/kernel.cl"
    ""
    "bandwidth"
  )
  # xrt_create_xclbin is macro defined in utils.cmake for generating xclbin
  xrt_create_xclbin(
    "kernel"
    ""
  )
endif()

install(TARGETS ${TESTNAME}
  RUNTIME DESTINATION ${INSTALL_DIR}/${TESTNAME})

=== tests/unit_test/cuselect/Makefile ===
# Copyright (C) 2016-2017 Xilinx, Inc
#
# Licensed under the Apache License, Version 2.0 (the "License"). You may
# not use this file except in compliance with the License. A copy of the
# License is located at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations
# under the License.

XOCC := $(XILINX_SDX)/bin/xocc
EMCONFIGUTIL := $(XILINX_SDX)/bin/emconfigutil
MODE := hw_emu
DSA := xilinx_vcu1525_dynamic_5_1

# % env XILINX_SDX=/proj/xbuilds/2018.3_daily_latest/installs/lin64/SDx/2018.3 make xclbin
# % env XILINX_SDX=/proj/xbuilds/2018.3_daily_latest/installs/lin64/SDx/2018.3 make emconfig
# % run.sh make host.exe
# % run.sh ./host.exe cuselect.xclbin

# sources
KERNEL_SRC := vadd.cl
HOST_SRC := main.cpp

# targets
HOST_EXE := host.exe
XOS := cuselect.$(MODE).xo
XCLBIN := cuselect.$(MODE).xclbin
EMCONFIG_FILE := emconfig.json

# flags
XOCC_LINK_OPTS := \
--nk vadd:4 \
--sp vadd_1.A:bank0 --sp vadd_1.B:bank1 --sp vadd_1.C:bank2 --sp vadd_1.D:bank3 \
--sp vadd_2.A:bank1 --sp vadd_2.B:bank2 --sp vadd_2.C:bank3 --sp vadd_2.D:bank0 \
--sp vadd_3.A:bank2 --sp vadd_3.B:bank3 --sp vadd_3.C:bank0 --sp vadd_3.D:bank1 \
--sp vadd_4.A:bank3 --sp vadd_4.B:bank0 --sp vadd_4.C:bank1 --sp vadd_4.D:bank2 \

XOCC_COMMON_OPTS := -s -t $(MODE) --platform $(DSA)
CFLAGS := -g -std=c++14 -I$(XILINX_XRT)/include
LFLAGS := -L$(XILINX_XRT)/lib -lxilinxopencl -lpthread -lrt
NUMDEVICES := 1

# run time args
EXE_OPT := cuselect.$(MODE).xclbin

# primary build targets
.PHONY: xclbin compile all clean run

xclbin:  $(XCLBIN)
compile: $(HOST_EXE)

all: clean xclbin compile run

clean:
	-$(RM) $(EMCONFIG_FILE) $(HOST_EXE) $(XCLBIN) $(XOS)

# kernel rules
$(XOS): $(KERNEL_SRC)
	$(RM) $@
	$(XOCC) $(XOCC_COMMON_OPTS) -c -o $@ $+


$(XCLBIN): $(XOS)
	$(XOCC) $(XOCC_COMMON_OPTS) -l -o $@ $+ $(XOCC_LINK_OPTS)

# host rules
$(HOST_EXE): $(HOST_SRC)
	g++ $(CFLAGS) -o $@ $+ $(LFLAGS)
	@echo 'Compiled Host Executable: $(HOST_EXE)'

$(EMCONFIG_FILE):
	$(EMCONFIGUTIL) --nd $(NUMDEVICES) --od . --platform $(DSA)

run: $(XCLBIN) $(HOST_EXE) $(EMCONFIG_FILE)
	./host.exe $(EXE_OPT)

=== src/runtime_src/core/common/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2022-2025 Advanced Micro Devices, Inc. All rights reserved.
if (NOT XRT_BASE)
  return()
endif()

add_subdirectory(api)
add_subdirectory(xdp)
add_subdirectory(runner)

if(CMAKE_VERSION VERSION_LESS "3.18.0")
  message(WARNING "CMake version is less than 3.18.0, build of submodule aiebu disabled")
elseif (${CMAKE_CXX_COMPILER} MATCHES "(arm64|ARM64)")
  message(WARNING "Compiling for ARM64, build of submodule aiebu disabled")
elseif (NOT XRT_EDGE)
  set(AIEBU_COMPONENT ${XRT_BASE_COMPONENT})
  set(AIEBU_DEV_COMPONENT ${XRT_BASE_DEV_COMPONENT})
  set(AIEBU_UPSTREAM ${XRT_UPSTREAM})
  xrt_add_subdirectory(aiebu)
else()
  message(WARNING "Edge device, build of submodule aiebu disabled")
endif()

add_library(core_common_library_objects OBJECT
  archive.cpp
  config_reader.cpp
  debug.cpp
  debug_ip.cpp
  device.cpp
  error.cpp
  info_aie.cpp
  info_aie2.cpp
  info_memory.cpp
  info_platform.cpp
  info_telemetry.cpp
  info_vmr.cpp
  memaccess.cpp
  message.cpp
  module_loader.cpp
  query_requests.cpp
  sensor.cpp
  system.cpp
  thread.cpp
  time.cpp
  trace.cpp
  usage_metrics.cpp
  utils.cpp
  sysinfo.cpp
  xclbin_parser.cpp
  xclbin_swemu.cpp
  smi.cpp
  )

target_include_directories(core_common_library_objects
  PRIVATE
  ${XRT_SOURCE_DIR}/runtime_src
  ${XRT_SOURCE_DIR}/runtime_src/core/common/elf
  )

set_property(SOURCE module_loader.cpp APPEND PROPERTY COMPILE_DEFINITIONS
  XRT_VERSION_MAJOR="${XRT_VERSION_MAJOR}"
  XRT_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
  XRT_LIB_DIR="${CMAKE_INSTALL_LIBDIR}"
  )

# The scheduler object files are for auto config of scheduler. These
# files reference xrt_core symbols, hence are excluded from
# xrt_corecommon shared library and instead linked explicitly into
# client (core) libraries
add_library(core_common_objects OBJECT scheduler.cpp)
target_include_directories(core_common_objects
  PRIVATE
  ${XRT_SOURCE_DIR}/runtime_src
  )

add_library(xrt_coreutil SHARED
  $<TARGET_OBJECTS:core_common_library_objects>
  $<TARGET_OBJECTS:core_common_runner_objects>
  $<TARGET_OBJECTS:core_common_api_library_objects>
  $<TARGET_OBJECTS:core_common_xdp_profile_objects>
  )

add_library(xrt_coreutil_static STATIC
  $<TARGET_OBJECTS:core_common_library_objects>
  $<TARGET_OBJECTS:core_common_runner_objects>
  $<TARGET_OBJECTS:core_common_api_library_objects>
  $<TARGET_OBJECTS:core_common_xdp_profile_objects>
  )

set_target_properties(xrt_coreutil PROPERTIES
  VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
  )

if (NOT WIN32)
  # On linux use xrt_coreutil.a
  set_target_properties(xrt_coreutil_static PROPERTIES OUTPUT_NAME "xrt_coreutil")
endif()

################################################################
# Define include directories and definitions needed by any target that
# links with xrt_coreutil
# BUILD_INTERFACE is for targets within XRT that link with xrt_coreutil
# INSTALL_INTERFACE is for external targets that link XRT::xrt_coreutil
target_include_directories(xrt_coreutil
  PUBLIC
  $<BUILD_INTERFACE:${XRT_SOURCE_DIR}/runtime_src>
  $<INSTALL_INTERFACE:${XRT_INSTALL_INCLUDE_DIR}>
  )
  
target_include_directories(xrt_coreutil_static
  PUBLIC
  $<BUILD_INTERFACE:${XRT_SOURCE_DIR}/runtime_src>
  $<INSTALL_INTERFACE:${XRT_INSTALL_INCLUDE_DIR}>
  )

target_compile_definitions(xrt_coreutil_static
  PUBLIC
  $<BUILD_INTERFACE:XRT_STATIC_BUILD>
  $<INSTALL_INTERFACE:XRT_STATIC_BUILD>
  )

# Linking with xrt_coreutil_static requires that applications link
# with the same runtime library as xrt_coreutil_static
if (WIN32)
  target_compile_options(xrt_coreutil_static
    PUBLIC
    $<INSTALL_INTERFACE:/MT$<$<CONFIG:Debug>:d>>
    )
endif()

if (NOT WIN32)
  # Additional link dependencies for xrt_coreutil
  # xrt_uuid.h depends on uuid
  target_link_libraries(xrt_coreutil PRIVATE pthread dl PUBLIC uuid)

  # Targets of xrt_coreutil_static must link with these additional
  # system libraries
  target_link_libraries(xrt_coreutil_static INTERFACE uuid dl rt pthread)
endif()
################################################################
install(TARGETS xrt_coreutil xrt_coreutil_static
  EXPORT xrt-targets
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_COMPONENT} NAMELINK_COMPONENT ${XRT_BASE_DEV_COMPONENT}
  ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT})

=== src/runtime_src/tools/xclbinutil/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2024, Advanced Micro Devices, Inc. All rights Reserved.
#
# Signing xclbin images are currently only support on Linux
cmake_minimum_required(VERSION 3.5...4.0)
project(XCLBINUTIL)

# This cmake project depends on some other cmake util files
# which can be found in folder ${XRT_SOURCE_DIR}/CMake.
if ("${XRT_SOURCE_DIR}" STREQUAL "")
  message(FATAL_ERROR, "XRT_SOURCE_DIR is not set, 
          if building xclbinutil only please set it to point <XRT>/src folder")
endif()

# --- Helper CMake files includes ---
include (${XRT_SOURCE_DIR}/CMake/settings.cmake)
include (${XRT_SOURCE_DIR}/CMake/utilities.cmake)
include (${XRT_SOURCE_DIR}/CMake/boostUtil.cmake)

# cmake 3.19 and after emits warning about this policy not being set
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
  cmake_policy(SET CMP0110 NEW)
endif(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)

if(NOT WIN32)
  find_package(OpenSSL REQUIRED)
  if (NOT XRT_EDGE)
    # Cannot use find_package(PythonInterp REQUIRED) as it pollutes the
    # global space and later causes failure with find_package(pybind11 ...)
    # in src/python/pybind11/CMakeLists.txt
    find_program(PYTHON_EXECUTABLE python3)
  endif()
endif()

# Windows support coming soon
if(NOT WIN32)
  # On Ubuntu 16.04 CMake support is limited
  if ((${LINUX_FLAVOR} STREQUAL "ubuntu") AND ("x${LINUX_VERSION}x" STREQUAL "x16.04x"))
    set(RapidJSON_VERSION_MAJOR 0)
  else()
    find_package(RapidJSON REQUIRED)
  endif()
endif()

# Need pthreads for the boost processes
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# --- Git ---
find_package(Git)

IF(GIT_FOUND)
  MESSAGE(STATUS "Looking for GIT - found at ${GIT_EXECUTABLE}")
ELSE(GIT_FOUND)
  MESSAGE(FATAL_ERROR "Looking for GIT - not found")
endif(GIT_FOUND)

# --- XRT Variables ---
include (${XRT_SOURCE_DIR}/CMake/xrtVariables.cmake)
include (${XRT_SOURCE_DIR}/CMake/version.cmake)

include_directories(
  ${XRT_SOURCE_DIR}/runtime_src/core/include
  ${PROJECT_BINARY_DIR}/gen
  )

if (NOT XRT_EDGE)
  add_subdirectory(
    ${XRT_SOURCE_DIR}/runtime_src/tools/scripts 
    ${PROJECT_BINARY_DIR}/runtime_src/tools/scripts
    )
  enable_testing()
endif()

# ==-- x c l b i n u t i l --==================================================

# aie-pdi-transform only supports linux build currently
if(NOT WIN32)
  add_subdirectory(aie-pdi-transform)
endif()

set(XCLBINUTIL_NAME "xclbinutil")

set(XRT_LOADER_SCRIPTS ${XCLBINUTIL_NAME})

if(WIN32)
  # Add the command shell wrapper in addition to the bash shell wrapper.
  # Note: The bash shell wrapper is smart and will call this wrapper
  list(APPEND XRT_LOADER_SCRIPTS ${XCLBINUTIL_NAME}.bat)
endif()

file(GLOB XCLBINUTIL_FILES
  "DTC*.cxx"
  "FDT*.cxx"
  "CBOR.cxx"
  "RapidJsonUtilities.cxx"
  "KernelUtilities.cxx"
  "ElfUtilities.cxx"
  "FormattedOutput.cxx"
  "ParameterSectionData.cxx"
  "Section.cxx"     # Note: Due to linking dependency issue, this entry needs to be before the other sections
  "Section*.cxx"
  "Resources*.cxx"
  "XclBinClass.cxx"
  "XclBinSignature.cxx"
  "XclBinUtilities.cxx"
  "XclBinUtilMain.cxx"
)
set(XCLBINUTIL_FILES_SRCS ${XCLBINUTIL_FILES})

file(GLOB XCLBINUTIL_MAIN_FILE
  "xclbinutil.cxx"
)
set(XCLBINUTIL_SRCS ${XCLBINUTIL_MAIN_FILE} ${XCLBINUTIL_FILES_SRCS})

add_executable(${XCLBINUTIL_NAME} ${XCLBINUTIL_SRCS})

# Signing xclbin images currently is not support on windows
if(NOT WIN32)
  target_link_libraries(${XCLBINUTIL_NAME} PRIVATE crypto)
endif()

# Add compile definitions
if(NOT WIN32)
   if(${RapidJSON_VERSION_MAJOR} GREATER 0)
     target_compile_definitions(${XCLBINUTIL_NAME} PRIVATE ENABLE_JSON_SCHEMA_VALIDATION)
   endif()
endif()

target_link_libraries(${XCLBINUTIL_NAME} PRIVATE ${Boost_LIBRARIES} Threads::Threads)

# link the aie-pdi-transform static library
if(NOT WIN32)
   target_link_libraries(${XCLBINUTIL_NAME} PRIVATE transformcdo)
endif()

# Link required windows specific libraries with MinGW
if(WIN32 AND (CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
  target_link_libraries(${XCLBINUTIL_NAME} PRIVATE wsock32 ws2_32)
endif()

install (TARGETS ${XCLBINUTIL_NAME}
  RUNTIME DESTINATION ${XRT_INSTALL_UNWRAPPED_DIR} COMPONENT ${XRT_BASE_COMPONENT})

# Do not install loader scripts if installing into system default
if (NOT XRT_INSTALL_BIN_DIR STREQUAL XRT_INSTALL_UNWRAPPED_DIR)
  install (PROGRAMS ${XRT_LOADER_SCRIPTS}
    DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT})
endif()

# ==-- x c l b i n t e s t --==================================================
SET(TEST_SUITE_NAME "xclbinutil")

include (${XRT_SOURCE_DIR}/CMake/unitTestSupport.cmake)

# OpenSSL encryption is only supported on linux
if(NOT WIN32 AND NOT XRT_SYSTEM_INSTALL)
  # -- Test Signing of the xclbin image using a CER formatted certificate
  xrt_add_test("signing-xclbin_CER" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/signXclbinCER.py")

  # -- Test Signing of the xclbin image using a DER formatted certificate
  xrt_add_test("signing-xclbin_DER" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/signXclbinDER.py")

  if (NOT XRT_NPU)
    # The xclbin image must contain atleast one section and platformVBNV information to meet
    # the expectations of Linux file command utility
    # -- Test --file-check option on valid and invalid xclbin images for Linux file command 
    set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/FileCheck")
    xrt_add_test("file-check" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/FileCheck/FileCheck.py ${TEST_OPTIONS}")
  endif()
  
  # -- Test SmartNic
  # Test: SmartNic Syntax
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic")
  xrt_add_test("smartnic-syntax" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic/SectionSmartNicSyntax.py ${TEST_OPTIONS}")

  # Test: SmartNic Schema
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic")
  xrt_add_test("smartnic-format" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic/SectionSmartNicFormat.py ${TEST_OPTIONS}")

  if (CMAKE_INSTALL_PREFIX STREQUAL "/opt/xilinx/xrt")
    # -- SoftKernel
    set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SoftKernel")
    xrt_add_test("soft-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SoftKernel/SectionSoftKernel.py ${TEST_OPTIONS}")
  endif()

  # -- Partion Metadata
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/PartitionMetadata")
  xrt_add_test("partition_metadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/PartitionMetadata/SectionPartitionMetadata.py ${TEST_OPTIONS}")

  # -- Fixed Kernels
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/FixedKernel")
  xrt_add_test("fixed-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/FixedKernel/FixedKernel.py ${TEST_OPTIONS}")

  # -- PS Kernels
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/PSKernel")
  xrt_add_test("ps-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/PSKernel/PSKernel.py ${TEST_OPTIONS}")

  # -- Binary Images
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/BinaryImages")
  xrt_add_test("binary-images" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/BinaryImages/BinaryImages.py ${TEST_OPTIONS}")

  # -- Single Subsection
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SingleSubsection")
  xrt_add_test("single-subsection" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SingleSubsection/SingleSubsection.py ${TEST_OPTIONS}")

  # -- AIE Partition
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AIEPartition")
  xrt_add_test("aie-partition" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AIEPartition/AIEPartition.py ${TEST_OPTIONS}")

  # -- BMC Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/BMC")
  xrt_add_test("bmc" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/BMC/BMCSection.py ${TEST_OPTIONS}")

  # -- MCS Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/MCS")
  xrt_add_test("mcs" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/MCS/MCSSection.py ${TEST_OPTIONS}")

  # -- IP_MEDATADA Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/IPMetadata")
  xrt_add_test("ip-metadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/IPMetadata/IPMetadata.py ${TEST_OPTIONS}")

  # -- AIE RESOURCES BIN Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieResourcesBin")
  xrt_add_test("AieResourcesBin" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieResourcesBin/SectionAieResourcesBin.py ${TEST_OPTIONS}")

  # -- AIE TRACE METADATA Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieTraceMetadata")
  xrt_add_test("AieTraceMetadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieTraceMetadata/SectionAieTraceMetadata.py ${TEST_OPTIONS}")


endif()


if (WIN32)
  set(GTEST_ROOT "C:/Xilinx/XRT/ext")
endif()

find_package(GTest)

if (GTEST_FOUND AND NOT XRT_SYSTEM_INSTALL)
  set(UNIT_TEST_NAME "xclbintest")

  include_directories(${GTEST_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})

  # Build everything in the unittest directory
  file(GLOB XCLBINTEST_FILES
    "unittests/*.cxx"
  )

  set(XCLBINTEST_SRCS ${XCLBINTEST_FILES} ${XCLBINUTIL_FILES_SRCS})
  add_executable(${UNIT_TEST_NAME} ${XCLBINTEST_SRCS})

  if(WIN32)
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE Boost::program_options Boost::system )
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE ${GTEST_BOTH_LIBRARIES})
  else()
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE ${Boost_LIBRARIES} ${GTEST_BOTH_LIBRARIES} pthread crypto)

    if(NOT (${RapidJSON_VERSION_MAJOR} EQUAL 0))
      target_compile_definitions(${UNIT_TEST_NAME} PRIVATE ENABLE_JSON_SCHEMA_VALIDATION)
    endif()
  endif()

  # link the aie-pdi-transform static library
  if(NOT WIN32)
     target_link_libraries(${UNIT_TEST_NAME} PRIVATE transformcdo)
  endif()

  # Add the test
  set(TEST_EXECUTABLE "${CMAKE_CURRENT_BINARY_DIR}/${UNIT_TEST_NAME}")
  set(TEST_OPTIONS "--quiet --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/test_data")
  xrt_add_test(${UNIT_TEST_NAME} "${TEST_EXECUTABLE}" "${TEST_OPTIONS}")

else()
  message (STATUS "GTest was not found, skipping generation of test executables")
endif()
# -----------------------------------------------------------------------------

=== src/runtime_src/xdp/profile/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Advanced Micro Devices, Inc.  All rights reserved.
#

set(PROFILE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

# Build the XDP core library here.  We build the same for Windows and Linux.
file(GLOB XDP_CORE_FILES
  "${PROFILE_DIR}/plugin/vp_base/*.h"
  "${PROFILE_DIR}/plugin/vp_base/*.cpp"
  "${PROFILE_DIR}/database/*.h"
  "${PROFILE_DIR}/database/*.cpp"
  "${PROFILE_DIR}/database/dynamic_info/*.h"
  "${PROFILE_DIR}/database/dynamic_info/*.cpp"
  "${PROFILE_DIR}/database/events/*.h"
  "${PROFILE_DIR}/database/events/*.cpp"
  "${PROFILE_DIR}/database/events/creator/*.h"
  "${PROFILE_DIR}/database/events/creator/*.cpp"
  "${PROFILE_DIR}/database/static_info/*.h"
  "${PROFILE_DIR}/database/static_info/*.cpp"
  "${PROFILE_DIR}/database/static_info/filetypes/*.cpp"
  "${PROFILE_DIR}/database/static_info/filetypes/*.h"
  "${PROFILE_DIR}/device/*.h"
  "${PROFILE_DIR}/device/*.cpp"
  "${PROFILE_DIR}/device/ioctl_monitors/*.h"
  "${PROFILE_DIR}/device/ioctl_monitors/*.cpp"
  "${PROFILE_DIR}/device/mmapped_monitors/*.h"
  "${PROFILE_DIR}/device/mmapped_monitors/*.cpp"
  "${PROFILE_DIR}/writer/vp_base/*.h"
  "${PROFILE_DIR}/writer/vp_base/*.cpp"
  )

add_library(xdp_core SHARED ${XDP_CORE_FILES})
add_dependencies(xdp_core xrt_coreutil)

if (XDP_CLIENT_BUILD_CMAKE STREQUAL "yes")
  target_compile_definitions(xdp_core PRIVATE XDP_CLIENT_BUILD=1)
endif()

target_link_libraries(xdp_core PRIVATE xrt_coreutil)

set_target_properties(xdp_core PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

# xdp_core is not an end-user link library, so skip the name link
# and do not add to xrt-targets.
install(TARGETS xdp_core
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_COMPONENT} NAMELINK_SKIP)

# Build the individual plugins
add_subdirectory(plugin)

=== src/runtime_src/core/edge/common_em/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
SET (Protobuf_DEBUG)
INCLUDE(FindProtobuf)
FIND_PACKAGE(Protobuf REQUIRED)

include_directories (
${PROTOBUF_INCLUDE_DIR}
)
# Generate Cpp files from Proto file
file(GLOB PROTO_SRC_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/*.proto"
  )

PROTOBUF_GENERATE_CPP(ProtoSources ProtoHeaders ${PROTO_SRC_FILES})

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

add_custom_target(edge_emulation_generated_code DEPENDS ${ProtoSources} ${ProtoHeaders})
file(GLOB COMMON_EM_SRC_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/*.cxx"
  )

add_definitions(-DXCLHAL_MAJOR_VER=1 -DXCLHAL_MINOR_VER=0)

add_library(common_em_objects OBJECT ${COMMON_EM_SRC_FILES} ${ProtoHeaders} ${ProtoSources})

set(CURR_SOURCE "")
add_library(common_em STATIC ${CURR_SOURCE}
  $<TARGET_OBJECTS:common_em_objects>
  )

add_dependencies(common_em edge_emulation_generated_code)

set_target_properties(common_em PROPERTIES VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION})

target_link_libraries(common_em
  PRIVATE
  ${PROTOBUF_LIBRARY}
  xrt_coreutil
  dl
  pthread
  crypt
  rt
  )

=== src/runtime_src/core/tools/xbmgmt2/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2022 Advanced Micro Devices, Inc. All rights reserved.
#
# Collect files outside of this directory
file(GLOB XBMGMT_V2_BASE_FILES
  "xbmgmt.cpp"
  "../common/XBMain.cpp"
  "../common/XBUtilitiesCore.cpp"
  "../common/XBUtilities.cpp"
  "../common/JSONConfigurable.cpp"
  "../common/SubCmd.cpp"
  "../common/SubCmdJsonObjects.cpp"
  "../common/SubCmdConfigureInternal.cpp"
  "../common/SubCmdExamineInternal.cpp"
  "../common/XBHelpMenusCore.cpp"
  "../common/XBHelpMenus.cpp"
  "../common/OptionOptions.cpp"
  "../common/ProgressBar.cpp"
  "../common/BusyBar.cpp"
  "../common/Process.cpp"
  "../common/reports/*.cpp"
  "../common/reports/aie/*.cpp"
  "../common/Report.cpp"
  "../common/SmiWatchMode.cpp"
  "../common/PsKernelUtilities.cpp"
  "../common/Table2D.cpp"
  "../common/SmiDefault.cpp"
)

# Collect local directory files
file(GLOB XBMGMT_V2_SUBCMD_FILES
  "SubCmdProgram.cpp"
  "SubCmdReset.cpp"
  "SubCmdExamine.cpp"
  "SubCmdAdvanced.cpp"
  "SubCmdDump.cpp"
  "SubCmdConfigure.cpp"
  "OO_Hotplug.cpp"
  "OO_UpdateBase.cpp"
  "OO_FactoryReset.cpp"
  "OO_UpdateShell.cpp"
  "OO_ChangeBoot.cpp"
  "OO_UpdateXclbin.cpp"
  "OO_Input.cpp"
  "OO_Retention.cpp"
  "Report*.cpp"
  "flash/*.cpp"
)

# Merge the files into one collection
set(XBMGMT_V2_SRCS ${XBMGMT_V2_BASE_FILES} ${XBMGMT_V2_SUBCMD_FILES})

# Determine the name of the executable
if(WIN32)
  set(XBMGMT2_NAME "xbmgmt")     # Yes, on windows the file name will be xbmgmt
  set(XRT_LOADER_SCRIPTS "xbmgmt" "xbmgmt.bat")
else()
  set(XBMGMT2_NAME "xbmgmt2")
  set(XRT_LOADER_SCRIPTS "xbmgmt")
endif()

add_executable(${XBMGMT2_NAME} ${XBMGMT_V2_SRCS})

# Determine what functionality should be added
if (NOT XRT_EDGE)
  target_compile_definitions(${XBMGMT2_NAME} PRIVATE ENABLE_NATIVE_SUBCMDS_AND_REPORTS)
else()
  target_compile_definitions(${XBUTIL2_NAME} PRIVATE ENABLE_DEFAULT_ONE_DEVICE_OPTION)
endif()

# Static build is a Linux / Ubuntu option only
if (XRT_STATIC_BUILD)
  add_executable(${XBMGMT2_NAME}_static ${XBMGMT_V2_SRCS})
  target_link_options(${XBMGMT2_NAME}_static PRIVATE "-static" "-L${Boost_LIBRARY_DIRS}")
  target_compile_definitions(${XBMGMT2_NAME}_static PRIVATE ENABLE_NATIVE_SUBCMDS_AND_REPORTS)
  # Bypass FindBoost versions and just link explicitly with boost libraries
  # The -static link option will pick the static libraries. 
  target_link_libraries(${XBMGMT2_NAME}_static
    PRIVATE
    xrt_coreutil_static
    boost_system
    boost_program_options
    -Wl,--whole-archive rt pthread -Wl,--no-whole-archive
    uuid
    dl
  )
  set_target_properties(${XBMGMT2_NAME}_static PROPERTIES INSTALL_RPATH "")
  install(TARGETS ${XBMGMT2_NAME}_static
    RUNTIME DESTINATION ${XRT_INSTALL_UNWRAPPED_DIR} COMPOMENT ${XRT_BASE_COMPONENT})
endif()

target_link_libraries(${XBMGMT2_NAME}
  PRIVATE
  xrt_coreutil
  ${Boost_FILESYSTEM_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
  )
  
# Add the supporting libraries
if(WIN32)
  target_link_libraries(${XBMGMT2_NAME} PRIVATE ws2_32)
else()
  target_link_libraries(${XBMGMT2_NAME} PRIVATE pthread uuid dl)
endif()

if (NOT XRT_EDGE)
  install (TARGETS ${XBMGMT2_NAME}
    RUNTIME DESTINATION ${XRT_INSTALL_UNWRAPPED_DIR} COMPONENT ${XRT_BASE_COMPONENT})

  # Do not install loader scripts if installing into system default
  if (NOT XRT_INSTALL_BIN_DIR STREQUAL XRT_INSTALL_UNWRAPPED_DIR)
    install (PROGRAMS ${XRT_LOADER_SCRIPTS}
      DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT})
  endif()
endif()

=== debian/control ===
Source: xrt
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
	   Nobuhiro Iwamatsu <iwamatsu@debian.org>,
	   Mario Limonciello <superm1@debian.org>,
Build-Depends: cmake,
	debhelper-compat (= 13),
	doxygen [amd64],
	git,
	help2man,
	libboost-filesystem-dev,
	libboost-program-options-dev,
	libboost-system-dev,
	libdrm-dev,
	libncurses-dev,
	libprotobuf-dev,
	libssl-dev,
	libudev-dev,
	libyaml-dev,
	lsb-release [amd64],
	ocl-icd-opencl-dev,
	ocl-icd-dev,
	pkgconf,
	protobuf-compiler,
	pybind11-dev,
	rapidjson-dev,
	systemtap-sdt-dev,
	uuid-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.xilinx.com/products/design-tools/vitis/xrt.html
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/xrt.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/xrt

Package: libxrt2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libxrt1 (<< ${binary:Version})
Conflicts: libxrt1
Replaces: libxrt1
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for xrt.

Package: python3-xrt
Architecture: arm64 amd64
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - Python bindings
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides Python bindings for XRT.

Package: libxrt-dev
Architecture: arm64 amd64
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - development files
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the development environment for xrt.

Package: libxrt-utils
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the xrt project.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_UPSTREAM_DEBIAN=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --sourcedir=src -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install
	# man pages
	mkdir -p debian/libxrt-utils/usr/share/man/man1
	# doesn't work for xrt-runner xrt-smi xrt-tracer
	for bin in xclbinutil xrt-replay; do \
	  LD_LIBRARY_PATH=debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE) help2man debian/tmp/usr/bin/$$bin > debian/libxrt-utils/usr/share/man/man1/$$bin.1; \
	done
	# bash completion
	mkdir -p debian/libxrt-utils/usr/share/bash-completion/completions
	install -m 644 debian/tmp/usr/share/completions/xbutil-bash-completion debian/libxrt-utils/usr/share/bash-completion/completions/xbutil

override_dh_auto_test:
	-dh_auto_test
